unit IE_D1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.Imaging.pngimage, Vcl.Controls, XData.Web.Dataset,
  WEBLib.Buttons, Vcl.StdCtrls, WEBLib.StdCtrls, WEBLib.DBCtrls, Data.DB,
  WEBLib.DB, XData.Web.JsonDataset;

type
  TfrmIED1 = class(TWebForm)
    WebLabel1: TWebLabel;
    WebDBEdit1: TWebDBEdit;
    btSaveDet: TWebSpeedButton;
    btDelDet: TWebSpeedButton;
    wsD1: TWebDataSource;
    btCancDet: TWebSpeedButton;
    WebMessageDlg: TWebMessageDlg;
    procedure btSaveDetClick(Sender: TObject);
    procedure btCancDetClick(Sender: TObject);
    procedure WebFormClose(Sender: TObject; var Action: TCloseAction);
    procedure btDelDetClick(Sender: TObject);
    procedure wdD1AfterApplyUpdates(Sender: TDataSet;  Info: TResolveResults);
  private
    { Private declarations }
    wdD1:TXDataWebDataSet;
  public
    { Public declarations }
    Class Function CreateForm(Action:String):TWebForm; Overload;
  end;

var
  frmIED1: TfrmIED1;

implementation

{$R *.dfm}

uses Main;


Class Function TfrmIED1.CreateForm(Action:String):TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    With TfrmIED1(AForm) Do Begin
      wdD1:=frmMain.wdD1;
      wdD1.AfterApplyUpdates:=wdD1AfterApplyUpdates;
      wsD1.DataSet:=wdD1;

      With wdD1 Do Begin
        If Action = 'INS' Then Begin
          Insert();
        End Else If Action = 'MOD' Then Begin
          Edit();
        End;
      End;
    End;
  end;
begin
  frmIED1:=TfrmIED1.CreateNew(@AfterCreate);

  If Action = 'INS' Then
    frmIED1.Caption:='New detail'
  Else
    frmIED1.Caption:='Edit detail';

  frmIED1.Popup:=True;
  //frmIED1.Border:=fbDialogSizeable;
  frmIED1.Border:=fbDialog;
end;
// -----------------------------------------------------------------------------
procedure TfrmIED1.btSaveDetClick(Sender: TObject);
begin
  If wdD1.State In [dsEdit, dsInsert] Then
    wdD1.Post();
  wdD1.ApplyUpdates();
end;
// -----------------------------------------------------------------------------
procedure TfrmIED1.btCancDetClick(Sender: TObject);
begin
  If wdD1.State In [dsEdit, dsInsert] Then
    wdD1.Cancel();

  ModalResult:=mrOk;
end;
// -----------------------------------------------------------------------------
procedure TfrmIED1.btDelDetClick(Sender: TObject);
begin
  wdD1.Delete();
  wdD1.ApplyUpdates();

  //ModalResult:=mrOk;
end;
// -----------------------------------------------------------------------------
procedure TfrmIED1.wdD1AfterApplyUpdates(Sender: TDataSet;  Info: TResolveResults);
Var i:Smallint;
  ResolveInfo:TResolveInfo;
begin
  For I:=0 to Length(Info.Records)-1 Do Begin
    ResolveInfo:=Info.Records[I];
    //If ResolveInfo.Status = TUpdateStatus.usResolveFailed Then Begin
    If ResolveInfo.Error <> '' Then Begin
      WebMessageDlg.ShowDialog(ResolveInfo.Error, mtError, [mbOk], Nil);
      Exit;  // al primo errore esce !
    End;
  End;

  ModalResult:=mrOk;
end;
// -----------------------------------------------------------------------------
procedure TfrmIED1.WebFormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

end.
