unit Main;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, XData.Web.Client, Data.DB, WEBLib.DB,
  XData.Web.JsonDataset, XData.Web.Dataset, WEBLib.Grids, WEBLib.DBCtrls,
  WEBLib.ExtCtrls, WEBLib.StdCtrls, Vcl.StdCtrls, Vcl.Controls,
  XData.Web.Connection, Vcl.Imaging.pngimage, WEBLib.Buttons;

type
  TfrmMain = class(TWebForm)
    WebLabel6: TWebLabel;
    edDocPK: TWebDBEdit;
    edDescGrp: TWebDBEdit;
    WebGroupBox1: TWebGroupBox;
    grdDet1: TWebDBTableControl;
    wdM: TXDataWebDataSet;
    wsM: TWebDataSource;
    wdD1: TXDataWebDataSet;
    wsD1: TWebDataSource;
    wdcM: TXDataWebClient;
    DataConnection: TXDataWebConnection;
    btAddMas: TWebSpeedButton;
    btDelMas: TWebSpeedButton;
    btPrecMas: TWebSpeedButton;
    btSuccMas: TWebSpeedButton;
    btAddDet: TWebSpeedButton;
    btSalvaTutto: TWebSpeedButton;
    wdMDESCRIPTION: TStringField;
    wdMDATE_COLL: TStringField;
    wdMIN_COLL: TBooleanField;
    wdMINFO_CLI: TStringField;
    wdMTEMPER: TFloatField;
    wdD1ID_DET1: TIntegerField;
    wdD1DESCRIPTION: TStringField;
    wdD1DATE_COLL: TStringField;
    wdD1IN_COLL: TBooleanField;
    wdD1INFO_CLI: TStringField;
    wdD1TEMPER: TFloatField;
    wdMDET_1_TABLE: TXDataWebDatasetField;
    wdD1ID_MAS: TXDataWebEntityField;
    wdMID_MAS: TIntegerField;
    WebMessageDlg: TWebMessageDlg;
    procedure WebFormCreate(Sender: TObject);
    procedure btSaveAllClick(Sender: TObject);
    procedure btAddMasClick(Sender: TObject);
    procedure btDelMasClick(Sender: TObject);
    procedure btPrecMasClick(Sender: TObject);
    procedure btSuccMasClick(Sender: TObject);
    procedure btAddDetClick(Sender: TObject);
    procedure btDelSGrpClick(Sender: TObject);
    procedure btPostSGrpClick(Sender: TObject);
    procedure wdMAfterScroll(DataSet: TDataSet);
    procedure grdDet1GetCellChildren(Sender: TObject; ACol, ARow: Integer;
      AField: TField; AValue: string; AElement: TJSHTMLElementRecord);
    procedure wdD1NewRecord(DataSet: TDataSet);
    procedure grdDet1DblClickCell(Sender: TObject; ACol, ARow: Integer);
    procedure wdMNewRecord(DataSet: TDataSet);
    procedure wdMAfterApplyUpdates(Sender: TDataSet; Info: TResolveResults);
    procedure wdD1AfterApplyUpdates(Sender: TDataSet; Info: TResolveResults);
  private
    { Private declarations }
    IDMas,IDD1:Integer;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses IE_D1;

procedure TfrmMain.WebFormCreate(Sender: TObject);
begin
  DataConnection.Open();

  wdM.Load();
  wdD1.Load();
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btPrecMasClick(Sender: TObject);
begin
  wdM.Prior();
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btSuccMasClick(Sender: TObject);
begin
  wdM.Next;
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btAddMasClick(Sender: TObject);
begin
  With wdM Do Begin
    Insert();
  End;
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btDelMasClick(Sender: TObject);
begin
  wdM.Delete();
end;
// -----------------------------------------------------------------------------

procedure TfrmMain.wdMAfterScroll(DataSet: TDataSet);
begin
  wdD1.Close();
  wdD1.SetJsonData(wdMDET_1_TABLE.Value);
  wdD1.Open();
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.wdMNewRecord(DataSet: TDataSet);
begin
  DataSet.FieldByName('DET_1_TABLE').Value:=TJSArray.New();
end;

// -----------------------------------------------------------------------------

// ----------                       DETAIL

// -----------------------------------------------------------------------------
procedure TfrmMain.grdDet1GetCellChildren(Sender: TObject; ACol, ARow: Integer;
  AField: TField; AValue: string; AElement: TJSHTMLElementRecord);
Var Button: TWebButton;

  Procedure EditButtonClick(Sender: TObject);
    Procedure AfterShowModal(AValue: TModalResult);
    Begin
      // Se chiudo la finestra di editing senza fare modifiche  inutile 'refreshare'
      If Not (AValue In [mrClose, mrCancel])Then Begin
        // fa qualcosa
      End;
    End;

  Begin
    wdD1.First(); wdD1.MoveBy(ARow-1);

    //AElement.Element.style.setProperty('background-color','red');

    TfrmIED1.CreateForm('MOD');
    frmIED1.ShowModal(@AfterShowModal);
  End;
begin
  If ARow = 0 Then
    Exit;

  If CompareText(grdDet1.Columns[ACol].Title, 'Operation') = 0 Then Begin
    Button:=TWebButton.Create(Nil);
    Button.Caption:='Edit/Delete';
    Button.OnClick:=@EditButtonClick;
    Button.ElementClassName:='btn btn-warning btn-sm';
    Button.ParentElement:=AElement.Element;
    Button.WidthStyle:=TSizeStyle.ssAuto;
    Button.HeightStyle:=TSizeStyle.ssAuto;
  End;
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.grdDet1DblClickCell(Sender: TObject; ACol, ARow: Integer);

  Procedure AfterShowModal(AValue: TModalResult);
  Begin
    // Se chiudo la finestra di editing senza fare modifiche  inutile 'refreshare'
    If Not (AValue In [mrClose, mrCancel])Then Begin
      // fa qualcosa
    End;
  End;
begin
  If ARow = 0 Then
    Exit;

  wdD1.First(); wdD1.MoveBy(ARow-1);

  TfrmIED1.CreateForm('MOD');
  frmIED1.ShowModal(@AfterShowModal);
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btAddDetClick(Sender: TObject);
  Procedure AfterShowModal(AValue: TModalResult);
  Begin
    // Se chiudo la finestra di editing senza fare modifiche  inutile 'refreshare'
    If Not (AValue In [mrClose, mrCancel])Then Begin
      // fa qualcosa
    End;
  End;
begin
  TfrmIED1.CreateForm('INS');
  frmIED1.ShowModal(@AfterShowModal);
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.wdD1NewRecord(DataSet: TDataSet);
begin
  TJSObject(wdD1.CurrentData)['ID_MAS@xdata.ref'] :=
    Format('MASTER_TABLE(%d)', [TJSObject(wdM.CurrentData)['ID_MAS']]);

  wdD1.FieldByName('ID_Det1').AsInteger := Random(100);
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btPostSGrpClick(Sender: TObject);
begin
  wdD1.Post;
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btDelSGrpClick(Sender: TObject);
begin
  wdD1.Delete();
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.wdD1AfterApplyUpdates(Sender: TDataSet;  Info: TResolveResults);
Var i:Smallint;
  ResolveInfo:TResolveInfo;
begin
  For I:=0 to Length(Info.Records)-1 Do Begin
    ResolveInfo:=Info.Records[I];
    //If ResolveInfo.Status = TUpdateStatus.usResolveFailed Then Begin
    If ResolveInfo.Error <> '' Then Begin
      WebMessageDlg.ShowDialog(ResolveInfo.Error, mtError, [mbOk], Nil);
      Exit;  // al primo errore esce !
    End;
  End;

  ModalResult:=mrOk;
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.btSaveAllClick(Sender: TObject);
begin
  If wdM.State In [dsEdit, dsInsert] Then
    wdM.Post();
  wdM.ApplyUpdates();
end;
// -----------------------------------------------------------------------------
procedure TfrmMain.wdMAfterApplyUpdates(Sender: TDataSet;  Info: TResolveResults);
begin
  // Get progressive just inserted
  edDocPK.Text:=String(TJSObject(wdM.CurrentData)['ID_MAS']);
end;

end.
