
CREATE TABLE MASTER_TABLE (
  ID_MAS         INTEGER NOT NULL PRIMARY KEY, 

  DESCRIPTION    VARCHAR(50), 
  DATE_COLL      DATETIME2,   
  IN_COLL        BIT NOT NULL DEFAULT (1),
  INFO_CLI       TEXT, 
  TEMPER         NUMERIC(10,2)
);


CREATE TABLE DET_1_TABLE (  
  ID_MAS         INTEGER NOT NULL, 
  ID_DET1        INTEGER NOT NULL, 

  DESCRIPTION    VARCHAR(50), 
  DATE_COLL      DATETIME2,   
  IN_COLL        BIT NOT NULL DEFAULT (1),
  INFO_CLI       TEXT, 
  TEMPER         NUMERIC(10,2),

  PRIMARY KEY (ID_MAS, ID_DET1),

  CONSTRAINT FK_DET1TABLE FOREIGN KEY (ID_MAS) REFERENCES MASTER_TABLE(ID_MAS) ON DELETE CASCADE ON UPDATE CASCADE
);


CREATE TABLE DET_2_TABLE (  
  ID_MAS         INTEGER NOT NULL, 
  ID_DET1        INTEGER NOT NULL, 
  ID_DET2        INTEGER NOT NULL, 

  DESCRIPTION    VARCHAR(50), 
  DATE_COLL      DATETIME2,   
  IN_COLL        BIT NOT NULL DEFAULT (1),
  INFO_CLI       TEXT, 
  TEMPER         NUMERIC(10,2),

  PRIMARY KEY (ID_MAS, ID_DET1, ID_DET2),

  CONSTRAINT FK_DET2TABLE FOREIGN KEY (ID_MAS,ID_DET1) REFERENCES DET_1_TABLE(ID_MAS,ID_DET1) ON DELETE CASCADE
);
